// Play_AV.cpp
//
// 1)  title.wma
// 2)  intro.wmv
// 3)  title.wma
//    "Escape", "End" - .
// https://pastebin.com/Gp0UYxLF

#ifdef _MSC_VER
#pragma comment(lib,"winmm.lib")
#pragma comment(lib,"vfw32.lib")
#endif
#include <windows.h>
#include <vfw.h>
char* GAppname="Play Audio Video";
void mb(char* s);
char* appBaseDir();
#define	WM_PLAY_SOUND			(WM_APP+100)
#define	WM_PLAY_SOUND_DESTROY	(WM_PLAY_SOUND+0)
class CPlaySound
{
public:
	char m_svFilename[MAX_PATH];
	char m_svError[128];
	DWORD ThreadId;
	CPlaySound(char* svFilename);
	BOOL Resolved(){return ThreadId;}
	char* GetError(){return *m_svError ? m_svError : NULL;}
};

DWORD __stdcall SoundThreadEntry(void*);
CPlaySound* GPlaySound;

CPlaySound::CPlaySound(char* svFilename) {
	*m_svError=0;
	*m_svFilename=0;
	ThreadId=1;
	lstrcpy(m_svFilename,svFilename);
	HANDLE hThread=CreateThread(NULL,0,SoundThreadEntry,this,0,&ThreadId);
	if(!hThread)
	lstrcpy(m_svError,"Failed. Could not create sound thread.\nYour system may be misbehaving.");
	else
	CloseHandle(hThread);
}

DWORD __stdcall SoundThreadEntry(void* Arg) {
	CPlaySound* arg=(CPlaySound*)Arg;
	char svBuff[512];
	MCI_OPEN_PARMS MciOpenParm;
	MCI_PLAY_PARMS MciPlayParm;
	MCI_GENERIC_PARMS MciGenParm;
	MCI_STATUS_PARMS MciStatParm;
	MciOpenParm.dwCallback=NULL;
	MciOpenParm.wDeviceID=0;
	MciOpenParm.lpstrDeviceType=NULL;
	MciOpenParm.lpstrElementName=arg->m_svFilename;
	MciOpenParm.lpstrAlias=NULL;
	DWORD dwRet=mciSendCommand(0,MCI_OPEN,MCI_OPEN_ELEMENT,(DWORD)(LPMCI_OPEN_PARMS)&MciOpenParm);
	if(dwRet) {
		wsprintf(svBuff,"Failed open \"%s\"",arg->m_svFilename);
		mb(svBuff);
	}
	UINT uDeviceID=MciOpenParm.wDeviceID;
	MciPlayParm.dwCallback=NULL;
	MciPlayParm.dwFrom=0;
	MciPlayParm.dwTo=0;
	MciStatParm.dwCallback=NULL;
	MciStatParm.dwItem=MCI_STATUS_LENGTH;
	dwRet=mciSendCommand(uDeviceID,MCI_STATUS,MCI_WAIT|MCI_STATUS_ITEM,(DWORD)&MciStatParm);
	if(dwRet) mb("Failed MCI \"Status\"");
	DWORD dwLen=MciStatParm.dwReturn;
	if(!MciStatParm.dwReturn) {
		wsprintf(svBuff,"Failed. The file \"%s\"\nempty!\n",arg->m_svFilename);
		mb(svBuff);
	}
	MSG msg;
	BOOL bDone,bPlay;
	bDone=bPlay=FALSE;
	while(!bDone) {
		if(PeekMessage(&msg,(HWND)-1,0,0,PM_REMOVE)) {
			if(WM_PLAY_SOUND_DESTROY==msg.message) {
				bDone=TRUE;
				MciGenParm.dwCallback=0;
				dwRet=mciSendCommand(uDeviceID,MCI_STOP,MCI_WAIT,(DWORD)(LPMCI_GENERIC_PARMS)&MciGenParm);
				if(dwRet)
					mb("Failed MCI \"Stop\"");
			} /* End if(WM_PLAY_SOUND_DESTROY)" */
		} /* End "if(PeekMessage)" */
		if(!bDone) {
			MciStatParm.dwCallback=NULL;
			MciStatParm.dwItem=MCI_STATUS_POSITION;
			dwRet=mciSendCommand(uDeviceID,MCI_STATUS,MCI_WAIT|MCI_STATUS_ITEM,(DWORD)&MciStatParm);
			if(dwRet)
				mb("Failed MCI \"Status\"");
			if(!bPlay) {
				dwRet=mciSendCommand(uDeviceID,MCI_PLAY,MCI_NOTIFY,(DWORD)(LPMCI_PLAY_PARMS)&MciPlayParm);
				if(dwRet)
					mb("Failed MCI \"Play\"");
				else
				bPlay=TRUE;
			} /* End "if(!bPlay)" */
			if(dwLen==MciStatParm.dwReturn)
			bDone=TRUE;
		} /* End "if(!bDone)" */
		Sleep(20);
	} /* End "while(!bDone)"*/
	mciSendCommand(uDeviceID,MCI_CLOSE,MCI_WAIT,(DWORD)(LPMCI_GENERIC_PARMS)&MciGenParm);
	if(dwRet)
		mb("Failed MCI \"Close\"");
	arg->ThreadId=0;
	return arg->ThreadId;
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE, LPSTR, int) {
	CreateMutex(NULL,0,GAppname);
	BOOL AlreadyRunning=(ERROR_ALREADY_EXISTS==GetLastError());
	if(AlreadyRunning)
	return 1;
	/* Play sound WMA. */
	char svFname_Wma[MAX_PATH];
	wsprintf(svFname_Wma,"%stitle.wma",appBaseDir());
	GPlaySound=new CPlaySound(svFname_Wma);
	char* pError=GPlaySound->GetError(); /* Check the error. */
	if(lstrlen(pError)) mb(pError);
	Sleep(50);
	/* Play video WMV.*/
	char svFname_Wmv[MAX_PATH];
	wsprintf(svFname_Wmv,"%sintro.wmv",appBaseDir());
	DWORD dwStyle=WS_POPUP | WS_VISIBLE | WS_MAXIMIZE | WS_THICKFRAME | WS_EX_TOPMOST | WS_EX_TRANSPARENT | MCIWNDF_NOOPEN | MCIWNDF_NOMENU | MCIWNDF_NOPLAYBAR | MCIWNDF_NOTIFYMODE | MCIWNDF_NOERRORDLG;
	HWND hwndMCI=MCIWndCreate(HWND_DESKTOP,hInstance,dwStyle,svFname_Wmv);
	if(!hwndMCI) mb("Failed MCIWndCreate");
	SendMessage(hwndMCI,MCIWNDM_SETZOOM,0,(LPARAM)(UINT)400);
	MCIERROR mErr=SendMessage(hwndMCI,MCI_PLAY,0,0);
	if(mErr) {
		DestroyWindow(hwndMCI);
		mb("Failed MCI_PLAY");
	}
	ShowCursor(FALSE);
	/* Wait end process or press key "End" or "Escape". */
	MSG msg;
	static char ptr[3];
	while(!GetAsyncKeyState(VK_END) && !GetAsyncKeyState(VK_ESCAPE)) {
		if(PeekMessage(&msg,NULL,0,0,PM_REMOVE)) {
			TranslateMessage(&msg);     
			DispatchMessage(&msg);
		} else {
			long lMode=MCIWndGetMode(hwndMCI,ptr,sizeof(ptr));
			if(MCI_MODE_STOP==lMode || MCI_MODE_NOT_READY==lMode)
			break;
		}
		Sleep(20);
	}
	DestroyWindow(hwndMCI);
	ShowCursor(TRUE);
	if(GPlaySound) {
		DWORD idThread=GPlaySound->Resolved();
		if(idThread)
			PostThreadMessage(idThread,WM_PLAY_SOUND_DESTROY,0,0);
	}
	/* Play sound WMA #2. */
	GPlaySound=new CPlaySound(svFname_Wma);
	pError=GPlaySound->GetError(); /* Check the error. */
	if(lstrlen(pError)) mb(pError);
	/* #2 - Wait end process or press key "End" or "Escape". */
	while(!GetAsyncKeyState(VK_END) && !GetAsyncKeyState(VK_ESCAPE)) {
		if(GPlaySound) {
			DWORD idThread=GPlaySound->Resolved();
			if(!idThread)
				break;
		} /* End "if(GPlaySound)" */
		Sleep(20);
	}
	return 0;
}

void mb(char* s) {
	UINT uType=MB_OK | MB_ICONINFORMATION |
	MB_SETFOREGROUND | MB_SYSTEMMODAL;
	int n=0;
	if(strstr(s,"Failed") || strstr(s,"Error"))
	++n;
	if(n) {
		uType &=~MB_ICONINFORMATION;
		uType |=MB_ICONWARNING;
	} MessageBox(GetActiveWindow(),s,GAppname,uType);
	if(n)
	ExitProcess(n);
}

char* appBaseDir() {
	static char Result[MAX_PATH];
	if(!Result[0]) {
		GetModuleFileName(GetModuleHandle(NULL),Result,(MAX_PATH));
		int i;
		for(i=lstrlen(Result)-1;i>0;--i) {
			if('\\'==Result[i-1] || '/'==Result[i-1])
			break;
		}
		Result[i]=0;
	}
	return Result;
}
